<template>
    <div
        class="review_collector__add_review"
        :class="[source]"
    >
        <template v-if="!showThanks">
            <div
                v-if="textBeforeRating"
                class="onbording__title"
            >
                {{ textBeforeRating }}
            </div>
            <div class="review_collector__stars">
                <div class="stars__title">
                    {{ title }}
                </div>
                <Stars
                    v-model="rating"
                    @input="updRating"
                />
            </div>
            <div
                v-if="textAfterRating"
                class="onbording__title"
            >
                {{ textAfterRating }}
            </div>
            <div
                v-if="showActions"
                class="d-flex align-items-center review_collector__actions"
            >
                <b-input
                    v-model="text"
                    class="input"
                    type="text"
                    placeholder="Share your comment"
                />
                <b-button
                    class="btn blue-btn"
                    :class="{'loading-xs': loading}"
                    :disabled="!rating.includes(true)"
                    @click="submit"
                >
                    <template v-if="!loading">
                        Submit
                    </template>
                </b-button>
            </div>
        </template>
        <div
            v-if="source == 'аpp_menu' && showThanks"
            class="review_collector__thanks"
        >
            Thank you for your feedback!
        </div>
    </div>
</template>

<script>
import Stars from './Stars.vue'

export default {
    components: {
        Stars
    },
    props: {
        source: {
            type: String,
        },
        title: {
            type: String,
            default: 'Rate your experience with the app so far:'
        },
        textAfterRating: String,
        textBeforeRating: String,
    },
    data() {
        return {
            loading: false,
            showActions: false,
            text: '',
            rating: [false, false, false, false, false],
            showThanks: false,
        }
    },
    methods: {
        submit() {
            this.loading = true
            const rating = this.rating.filter(el => el).length
            this.$emit('submit', {text: this.text || null, rating, source: this.source})
        },
        close() {
            this.showThanks = true
            setTimeout(() => {
                this.$emit('close')
                this.$store.commit('review/setField', {
                    field: 'showAddReview',
                    value: false
                })
            }, 2000)
        },
        updRating() {
            const topRating = this.rating.filter(el => el).length == 5
            if(topRating) {
                if(this.showActions) this.showActions = false
                this.submit()
            } else {
                if(!this.showActions) this.showActions = true
                if(this.loading) this.loading = false
            }

        }
    }
}
</script>

